#ifndef __BOTLOG_H__
#define __BOTLOG_H__


#include "globals.h"

#include "util/singleton.h"
#include "ivaria/reporter.h"
#include <iutil/vfs.h>

struct iConfigManager;
struct iObjectRegistry;

//logs used by Foxy's bot; add a name and header here for any new log you might want created
enum
{
    CSV_RECIPES,
    CSV_EXPLORING,
    CSV_CRAFTING,
    CSV_POS,
    MAX_BOTCSV
};

const csString RECIPE_HEADER = csString("DateTime,Item,Container,Tool,Ingredients\n");
const csString EXPLORING_HEADER = csString("DateTime,ToolName,X,Y,Z,Claim,ItemsCount,ItemName\n");
const csString CRAFTING_HEADER = csString("DateTime,ItemMade,UseMax,Ingredients\n");
const csString POS_HEADER = csString("DateTime,X,Y,Z\n");

const csString LOG_TEXT_SEP = csString(",");

// Used to create Comma Seperated Value files for general logging
// and takes advantage of ConfigManager and VFS which pslog cannot.
// This should be used only for day-to-day information needed in a
// consistent, readable format. Warnings and errors should go through pslog.
class BotLogCSV
{
    csRef<iFile> csvFile[MAX_BOTCSV];
    void StartLog(const char* logfile, iVFS* vfs, csString header, size_t maxSize, csRef<iFile>& csvFile);

public:
    BotLogCSV(iConfigManager* configmanager, iVFS* vfs);
    void Write(int type, csString& text);

};

/** @} */


#endif
